/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include <stdio.h>
#include <stdbool.h>




/* Maximum supported Custom Services */
//#define CYBLE_CUSTOMS_SERVICE_COUNT                  (0x02u)
//#define CYBLE_CUSTOMC_SERVICE_COUNT                  (0x00u)
//#define CYBLE_CUSTOM_SERVICE_CHAR_COUNT              (0x02u)
//#define CYBLE_CUSTOM_SERVICE_CHAR_DESCRIPTORS_COUNT  (0x02u)

/* Below are the indexes and handles of the defined Custom Services and their characteristics */
#define CYBLE_S1_SERVICE_INDEX   (0x00u) /* Index of S1 service in the cyBle_customs array */
#define CYBLE_S1_S1_C1_CHAR_INDEX   (0x00u) /* Index of S1_C1 characteristic */
#define CYBLE_S1_S1_C1_S1_C1_D1_DESC_INDEX   (0x00u) /* Index of S1_C1_D1 descriptor */
#define CYBLE_S1_S1_C1_S1_C1_CCCD_DESC_INDEX   (0x01u) /* Index of S1_C1_CCCD descriptor */
#define CYBLE_S1_S1_C2_CHAR_INDEX   (0x01u) /* Index of S1_C2 characteristic */
#define CYBLE_S1_S1_C2_S1_C2_D1_DESC_INDEX   (0x00u) /* Index of S1_C2_D1 descriptor */

#define CYBLE_S2_SERVICE_INDEX   (0x01u) /* Index of S2 service in the cyBle_customs array */
#define CYBLE_S2_S2_C1_CHAR_INDEX   (0x00u) /* Index of S2_C1 characteristic */
#define CYBLE_S2_S2_C1_S2_C1_D1_DESC_INDEX   (0x00u) /* Index of S2_C1_D1 descriptor */
#define CYBLE_S2_S2_C1_CLIENT_CHARACTERISTIC_CONFIGURATION_DESC_INDEX   (0x01u) /* Index of Client Characteristic Configuration descriptor */


#define CYBLE_S1_SERVICE_HANDLE   (0x000Cu) /* Handle of S1 service */
#define CYBLE_S1_S1_C1_DECL_HANDLE   (0x000Du) /* Handle of S1_C1 characteristic declaration */
#define CYBLE_S1_S1_C1_CHAR_HANDLE   (0x000Eu) /* Handle of S1_C1 characteristic */
#define CYBLE_S1_S1_C1_S1_C1_D1_DESC_HANDLE   (0x000Fu) /* Handle of S1_C1_D1 descriptor */
#define CYBLE_S1_S1_C1_S1_C1_CCCD_DESC_HANDLE   (0x0010u) /* Handle of S1_C1_CCCD descriptor */
#define CYBLE_S1_S1_C2_DECL_HANDLE   (0x0011u) /* Handle of S1_C2 characteristic declaration */
#define CYBLE_S1_S1_C2_CHAR_HANDLE   (0x0012u) /* Handle of S1_C2 characteristic */
#define CYBLE_S1_S1_C2_S1_C2_D1_DESC_HANDLE   (0x0013u) /* Handle of S1_C2_D1 descriptor */

#define CYBLE_S2_SERVICE_HANDLE   (0x0014u) /* Handle of S2 service */
#define CYBLE_S2_S2_C1_DECL_HANDLE   (0x0015u) /* Handle of S2_C1 characteristic declaration */
#define CYBLE_S2_S2_C1_CHAR_HANDLE   (0x0016u) /* Handle of S2_C1 characteristic */
#define CYBLE_S2_S2_C1_S2_C1_D1_DESC_HANDLE   (0x0017u) /* Handle of S2_C1_D1 descriptor */
#define CYBLE_S2_S2_C1_CLIENT_CHARACTERISTIC_CONFIGURATION_DESC_HANDLE   (0x0018u) /* Handle of Client Characteristic Configuration descriptor */

typedef enum
{
getpasskey=0x00,
connected, 
idle,
pendingflashwrite,
numericcomp,
L2cap,    
}customstate;
customstate presentstate=idle, paststate=idle;

uint32 passkey=0;
uint32 pow1=0;
uint8 command=0;
uint32 numcompkey;

void printdata(CYBLE_GATTC_HANDLE_VALUE_NTF_PARAM_T * data);
int _write(int file, char *ptr, int len)
{
int i;
file = file;
for (i = 0; i < len; i++)
{
UART_UartPutChar(*ptr++);
}
return len;
}
CYBLE_GAP_BD_ADDR_T device1;
CYBLE_GAPC_ADV_REPORT_T *scanreport;
uint8 k=0;
CYBLE_GAP_BD_ADDR_T peerdevice;
uint8 detectflag=0;
CYBLE_L2CAP_CBFC_CONN_IND_PARAM_T * cbfcRequest;
CYBLE_L2CAP_CBFC_CONNECT_PARAM_T cbfcPeerParameters;
uint16 l2capCid;
uint16 peerDevicePsm;
CYBLE_API_RESULT_T apiresult;

uint8 sendbuffer[1000];
uint8 receivebuffer[1000];

#define PEER_DEVICE_TX_CREDITS      (10)

#define LOCAL_DEVICE_PSM            (84)
#define LOCAL_DEVICE_MTU            (1024)
#define LOCAL_DEVICE_MPS            (1024)

CYBLE_L2CAP_CBFC_CONNECT_PARAM_T cbfcLocalParameters = 
{
    LOCAL_DEVICE_MTU,         /* MTU size of this device */
    LOCAL_DEVICE_MPS,         /* MPS size of this device */
    PEER_DEVICE_TX_CREDITS    /* Initial Credits given to peer device for Tx */
};
CYBLE_L2CAP_CBFC_RX_PARAM_T *cbfcRxParameter;
uint16 i=0;
uint8 data[4] = {5,6,7,8};
void stack_event_handler(uint32 eventCode, void * eventParam)
{
    switch(eventCode)
    {
        CYBLE_GAP_IOCAP_T iocap;
        case CYBLE_EVT_STACK_ON:        
        GREEN_Write(1);
        RED_Write(1);
        BLUE_Write(0);
        printf("STACK ON \r\n");
        CyBle_GapcStartScan(CYBLE_SCANNING_FAST );
        CYBLE_GAP_BD_ADDR_T myaddress;
        myaddress.type=0x00;
        for(i=0;i<6;i++)
        myaddress.bdAddr[i]=0x11;
        CyBle_SetDeviceAddress(&myaddress);
        printf("My device address is: ");
        for(i=0;i<6;i++)
        printf("%02X ",myaddress.bdAddr[i]);
        printf("\r\n");
        iocap=CYBLE_GAP_IOCAP_NOINPUT_NOOUTPUT;
        CyBle_GapSetIoCap(iocap);
        break;
        
        
        
        case CYBLE_EVT_GAPC_SCAN_PROGRESS_RESULT:
        scanreport = (CYBLE_GAPC_ADV_REPORT_T *) eventParam; 
        if(scanreport->data[5]==0x47  && scanreport->data[6]==0x41  && scanreport->data[7]==0x4E  && 
        scanreport->data[8]==0x49)
        {
            UART_UartPutString("CYBLE_EVT_GAPC_SCAN_PROGRESS_RESULT - Peripheral found\r\n");
            for(k=0;k<6;k++)
            {
                
            peerdevice.bdAddr[k]=scanreport->peerBdAddr[k];
            }
            peerdevice.type = scanreport->peerAddrType;
            detectflag=1;
            CyBle_GapcStopScan();            
            scanreport = NULL;
        }
        //printf("\r\n");
        break;
        
        
        
        case CYBLE_EVT_GAPC_SCAN_START_STOP:        
        if(CyBle_GetState()==CYBLE_STATE_DISCONNECTED)
        {  
          // connectionflag=0;
           UART_UartPutString("CYBLE_EVT_GAPC_SCAN_START_STOP - \r\n");
           if(detectflag==1)
           {
           CyBle_GapcConnectDevice(&peerdevice);
           detectflag=0;   
           }
           else
           {
            CyBle_GapcStartScan(CYBLE_SCANNING_FAST);
           }
        }
        printf("\r\n");
        break;
        
        
        
        //Have to figure out when this event will be called
        case CYBLE_EVT_GATT_CONNECT_IND:       
        GREEN_Write(0);
        RED_Write(1);
        BLUE_Write(1);
        //connHandle = *(CYBLE_CONN_HANDLE_T *)eventParam;
       // peerbdaddress.type=0x00;
        //CyBle_GapGetPeerBdAddr((connHandle.bdHandle),&peerbdaddress);
        UART_UartPutString("CYBLE_EVT_GATT_CONNECT_IND - Connection established. \r\n"); 
        //printf("The connected device address is %x %x %x : %x %x %x\r\n", peerbdaddress.bdAddr[5], peerbdaddress.bdAddr[4], peerbdaddress.bdAddr[3], peerbdaddress.bdAddr[2],peerbdaddress.bdAddr[1], peerbdaddress.bdAddr[0]);
        //CyBle_GattcExchangeMtuReq(cyBle_connHandle, CYBLE_GATT_MTU);
        //printf("MTU exchange request sent \r\n");
        printf("\r\n"); 
        CyBle_L2capCbfcRegisterPsm(LOCAL_DEVICE_PSM, 0);
        break;
        
        
        
        
        case CYBLE_EVT_GATT_DISCONNECT_IND:
        GREEN_Write(1);
        RED_Write(0);
        BLUE_Write(1);
        break;
        
        
        case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
        CyBle_GapcStartScan(CYBLE_SCANNING_FAST);
        break;
        
        
         case CYBLE_EVT_L2CAP_CBFC_CONN_IND:
            cbfcRequest = (CYBLE_L2CAP_CBFC_CONN_IND_PARAM_T *)eventParam;
            UART_UartPutString("CYBLE_EVT_L2CAP_CBFC_CONN_IND- connection event received\n\r");
            /* Cache the connection parameters and channel ID */
            cbfcPeerParameters.mtu = cbfcRequest->connParam.mtu;
            cbfcPeerParameters.mps = cbfcRequest->connParam.mps;
            cbfcPeerParameters.credit = cbfcRequest->connParam.credit;
            l2capCid = cbfcRequest->lCid;
            peerDevicePsm = cbfcRequest->psm;
            
            apiresult = CyBle_L2capCbfcConnectRsp(l2capCid, CYBLE_L2CAP_CONNECTION_SUCCESSFUL, &cbfcLocalParameters);
            // apiresult = CyBle_L2capCbfcConnectRsp(10U, CYBLE_L2CAP_CONNECTION_SUCCESSFUL, &cbfcLocalParameters);
            if(apiresult == CYBLE_ERROR_OK)
            {
            UART_UartPutString("Request accepted, confirmation sent");                    
            }
            printf("The value of l2capcid is %d \r\n", l2capCid);
            break;
        
            //PEER WRITING L2CAP DATA
             case CYBLE_EVT_L2CAP_CBFC_DATA_READ:
            UART_UartPutString("\r\n CYBLE_EVT_L2CAP_CBFC_DATA_READ- event triggered \r\n");
            /* New data received on the L2CAP channel */
            cbfcRxParameter = (CYBLE_L2CAP_CBFC_RX_PARAM_T *)eventParam; 
            printf("The data length is %d \r\n", cbfcRxParameter->rxDataLength);
            for (i=0;i<cbfcRxParameter->rxDataLength;i++)
            {
            printf("%02X ",cbfcRxParameter->rxData[i]);
            receivebuffer[i]=cbfcRxParameter->rxData[i];
            }
            printf("\r\n");

            break;
          
        //WHEN CLIENT READS DATA FROM SERVER    
        CYBLE_GATTC_READ_RSP_PARAM_T *readrespdata;    
        case CYBLE_EVT_GATTC_READ_RSP:        
        readrespdata = (CYBLE_GATTC_READ_RSP_PARAM_T *)eventParam;
        printf("CYBLE_EVT_GATTC_READ_RSP- DATA RECEIVED\r\n");    
        printf("The length of the characteristic read is %d \r\n", readrespdata->value.len);
        printf("The data is ");
        for (i=0;i<readrespdata->value.len;i++)
        {
        printf("%02X ", readrespdata->value.val[i]);
        }
        printf("\r\n");
        printf("\r\n");
        break;
           
        
        case CYBLE_EVT_L2CAP_CBFC_RX_CREDIT_IND:
        UART_UartPutString("\r\n CYBLE_EVT_L2CAP_CBFC_RX_CREDIT_IND \r\n");
        /* Peer device exhausted its Tx credits; send more */
        CyBle_L2capCbfcSendFlowControlCredit(l2capCid, PEER_DEVICE_TX_CREDITS);
        break;
            
        
        //WRITE RESPONSE EVENT
        case CYBLE_EVT_GATTC_WRITE_RSP:
        printf("CYBLE_EVT_GATTC_WRITE_RSP-Write response received");
        printf("\r\n");
        break; 
        
        
        //LONG_WRITE EVENT
        case CYBLE_EVT_GATTC_EXEC_WRITE_RSP:
        //executewriteresp = (CYBLE_GATTC_EXEC_WRITE_RSP_T *)eventParam;
        printf("CYBLE_EVT_GATTC_EXEC_WRITE_RSP-\r\n");
        //printf("The result is %x\r\n", executewriteresp->result);
        printf("\r\n");
        break;
        
             
        
        //NOTIFICATION EVENT
        case CYBLE_EVT_GATTC_HANDLE_VALUE_NTF :
        printf("CYBLE_EVT_GATTC_HANDLE_VALUE_NTF \r\n");
        printdata((CYBLE_GATTC_HANDLE_VALUE_NTF_PARAM_T *)eventParam);
        printf("\r\n");
        break;
        
        
        //LONG_READ EVENT
        CYBLE_GATTC_READ_RSP_PARAM_T *readblobresp;       
        case CYBLE_EVT_GATTC_READ_BLOB_RSP:
        readblobresp = (CYBLE_GATTC_READ_RSP_PARAM_T *)eventParam;
        printf("CYBLE_EVT_GATTC_READ_BLOB_RSP-\r\n");
        for (k=0;k<readblobresp->value.len;k++)
        printf("%02X ", readblobresp->value.val[k]);
        printf("\r\n");
        break;
        
        
//        case CYBLE_EVT_BASC_NOTIFICATION:
//        printf("CYBLE_EVT_BASC_NOTIFICATION\r\n");
//        CyBle_BascGetCharacteristicValue(cyBle_connHandle, 0x00, 0x00);
//        printf("\r\n");
//        break;
        
        
        
        //INDICATION EVENT
        case  CYBLE_EVT_GATTC_HANDLE_VALUE_IND:
        //indicationresp = (CYBLE_GATTC_HANDLE_VALUE_IND_PARAM_T *)eventParam;
        CyBle_GattcConfirmation (cyBle_connHandle);
        printf("CYBLE_EVT_GATTC_HANDLE_VALUE_IND \r\n");
        printdata((CYBLE_GATTC_HANDLE_VALUE_IND_PARAM_T *)eventParam);
        printf("\r\n");
        break;
        
        //authentication events
        //AUTHENTICATION REQUEST FROM CENTRAL
        case CYBLE_EVT_GAP_AUTH_REQ:
        UART_UartPutString("CYBLE_EVT_GAP_AUTH_REQ - AUTHENTICATION REQUEST FROM CENTRAL\r\n");
        printf("security=0x%x, bonding=0x%x, ekeySize=0x%x, err=0x%x \r\n",(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).security,(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");
        //the authreqreply will be sent by default       
         CyBle_GapAuthReq(cyBle_connHandle.bdHandle, &cyBle_authInfo);
        break;
        
        
//Negotiated information
        case CYBLE_EVT_GAP_SMP_NEGOTIATED_AUTH_INFO:
        UART_UartPutString("CYBLE_EVT_GAP_SMP_NEGOTIATED_AUTH_INFO - Central negotiated\r\n");
        printf("security=0x%x, bonding=0x%x, ekeySize=0x%x, err=0x%x \r\n",(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).security,(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");
        break;
        
        
        
        
        
//Event occurs when pairing is successful
        CYBLE_GAP_AUTH_INFO_T authInfo;
        case CYBLE_EVT_GAP_AUTH_COMPLETE:
        UART_UartPutString("CYBLE_EVT_GAP_AUTH_COMPLETE - Pairing completed successfully  \r\n");
        printf("security=0x%x, bonding=0x%x, ekeySize=0x%x, err=0x%x \r\n",
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).security,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
        authInfo = *(CYBLE_GAP_AUTH_INFO_T *)eventParam;
                printf("AUTHENTICATION_COMPLETED:\r\n");
            
                /* Authentication status of connection after pairing process*/
                if((authInfo.security)==0x00)
                {
                    printf("No Security\r\n");
                 }   
                else if((authInfo.security)==0x01)
                {
                    printf("Security: Unauthenticated and Encryption\r\n");
                }
                else if ((authInfo.security)==0x02)
                {
                    printf("security: Authentication and Encryption\r\n");
                }
                else if((authInfo.security)==0x03)
                {
                    printf("Unauthenticated and data signing\r\n");
                }
                else if ((authInfo.security)==0x04)
                {
                    printf("Authentication and data signing\r\n");
                }               
                /*Used Bonding or not*/
                if((*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding==CYBLE_GAP_BONDING_NONE)
                {
                    printf("Bonding: No \r\n");
                }
                else
                {
                    printf("Bonding:yes\r\n");
                }

                printf("eKeySize: 0x%x\r\n", (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize);
                printf("err: 0x%x\r\n",(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
                UART_UartPutString("\r\n");
                UART_UartPutString("\r\n");
        break;
                
         case CYBLE_EVT_GAP_DEVICE_CONNECTED:
         UART_UartPutString("\n\rCYBLE_EVT_GAP_DEVICE_CONNECTED\r\n ");
         //CyBle_GapAuthReq(cyBle_connHandle.bdHandle, &cyBle_authInfo);
         break;
        
        
      //Event prints the reason for authentication failure
        case CYBLE_EVT_GAP_AUTH_FAILED:       
        printf("CYBLE_EVT_GAP_AUTH_FAILED, reason- %x", *((CYBLE_GAP_AUTH_FAILED_REASON_T *)eventParam));
        switch(*((CYBLE_GAP_AUTH_FAILED_REASON_T *)eventParam))
        {
        case CYBLE_GAP_AUTH_ERROR_CONFIRM_VALUE_NOT_MATCH:
        UART_UartPutString("CONFIRM_VALUE_NOT_MATCH\r\n");
        break;                   
        case CYBLE_GAP_AUTH_ERROR_INSUFFICIENT_ENCRYPTION_KEY_SIZE:
        UART_UartPutString("INSUFFICIENT_ENCRYPTION_KEY_SIZE\r\n");
        break;                
        case CYBLE_GAP_AUTH_ERROR_UNSPECIFIED_REASON:
        UART_UartPutString("UNSPECIFIED_REASON\r\n");
        break;
        case CYBLE_GAP_AUTH_ERROR_AUTHENTICATION_TIMEOUT:
        UART_UartPutString("AUTHENTICATION_TIMEOUT\r\n");
        break;
        case CYBLE_GAP_AUTH_ERROR_LINK_DISCONNECTED:
        UART_UartPutString("LINK_DISCONNECTED\r\n");
        break;
        default:
        break;
        }
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");
        break;


        //this event triggers to indicate user to store bonding data to flash
        case CYBLE_EVT_PENDING_FLASH_WRITE:
        printf("CYBLE_EVT_PENDING_FLASH_WRITE \r\n");
        presentstate = pendingflashwrite;
        break;

        //This event is generated once the connection is established
        case CYBLE_EVT_GAP_ENHANCE_CONN_COMPLETE:
        UART_UartPutString("CYBLE_EVT_GAP_ENHANCE_CONN_COMPLETE\r\n");
        //CyBle_GapAuthReq(cyBle_connHandle.bdHandle, &cyBle_authInfo);
        printf("\r\n");
        break;
        
                    CYBLE_GAP_SMP_KEY_DIST_T KEY;
            case CYBLE_EVT_GAP_KEYINFO_EXCHNGE_CMPLT:
            /*Key Information exchange completed */


            printf("\r\n");
            printf("KEYINFO_EXCHANGE_COMPLETED\r\n");
            KEY= *(CYBLE_GAP_SMP_KEY_DIST_T *)eventParam;

            /*Print Long term Key */
            printf("Long term Key: ");
            for(uint8 j=0;j<CYBLE_GAP_SMP_LTK_SIZE;j++)
            {
               printf("%2.2X",KEY.ltkInfo[CYBLE_GAP_SMP_LTK_SIZE-j-1]);
            }


            /*Print Encrypted Diversifier*/
            printf("\r\nEncrypted Diversifier: ");

            for(uint8 j=0;j<2;j++)
            {
                printf("%2.2X",KEY.midInfo[1-j]);
            }

            /*Print Random Number*/
            printf("\r\nRandom Number:");
            for(uint8 j=2;j<CYBLE_GAP_SMP_MID_INFO_SIZE;j++)
            {
                printf("%2.2X",KEY.midInfo[CYBLE_GAP_SMP_MID_INFO_SIZE-j+1]);
            }

            /*Print Indentifier Resolving Key*/
            printf("\r\nIndentifier Resolving Key: ");
            for(uint8 j=0;j<CYBLE_GAP_SMP_IRK_SIZE;j++)
            {
                printf("%2.2X",KEY.irkInfo[CYBLE_GAP_SMP_IRK_SIZE-j-1]);
            }

            /*Print Address of peer device*/
            printf("\r\nPublic device/Static Random address: ");
            for(uint8 j=1;j<CYBLE_GAP_SMP_IDADDR_DATA_SIZE;j++)
            {
                printf("%2.2X",KEY.idAddrInfo[CYBLE_GAP_SMP_IDADDR_DATA_SIZE-j]);
            }

            /*Print Address type of peer Device*/
            printf("\r\nAddress Type:");
            if(KEY.idAddrInfo[0]==0x00)
            {
                printf("PUBLIC\r\n");
            }
            else
            {
                printf("RANDOM\r\n");
            }

            /*Print Connection Signature Resolving Key*/
            printf("\r\nConnection Signature Resolving Key: ");
            for(uint8 j=0;j<CYBLE_GAP_SMP_CSRK_SIZE;j++)
            {
                printf("%2.2X",KEY.csrkInfo[CYBLE_GAP_SMP_CSRK_SIZE-j-1]);
            }
            printf("\r\n");
            break;

            //EVENT TO ENTER PASSKEY DISPLAYED BY CENTRAL
            case CYBLE_EVT_GAP_PASSKEY_ENTRY_REQUEST:
            UART_UartPutString("CYBLE_EVT_GAP_PASSKEY_ENTRY_REQUEST - Peripheral is requested to enter passkey \r\n");
            //HANDLED IN MAIN FOR LOOP SINCE BLOCKING INSIDE EVENT HANDLER IS NOT RECOMMENDED
            presentstate = getpasskey;
            UART_UartPutString("\r\n");
            UART_UartPutString("\r\n");
            break;

            
            //EVENT TO DISPLAY PASSKEY FOR AUTHENTICATION
            case CYBLE_EVT_GAP_PASSKEY_DISPLAY_REQUEST:
            printf("CYBLE_EVT_GAP_PASSKEY_DISPLAY_REQUEST. Passkey is: %lu \r\n", *(uint32 *)eventParam);
            printf("Please enter the passkey on your Peer BLE device (peripheral)\r\n");
            UART_UartPutString("\r\n");
            UART_UartPutString("\r\n");
            break;
            
        //EVENT TO DISPLAY NUMERIC COMPARISON KEY           
        case CYBLE_EVT_GAP_NUMERIC_COMPARISON_REQUEST:
        numcompkey = *((uint32 *)eventParam);
        printf("CYBLE_EVT_GAP_NUMERIC_COMPARISON_REQUEST \r\n");
        printf("The numeric comparison key is %lu", (*(uint32 *)eventParam));
        UART_UartPutString("\r\n");
        presentstate=numericcomp;
        break;


        
        default:
        break;
    }
}
uint8 sendchunk=0;
void pinhandler()
{
    printf("pin interrupt\r\n");
    Pin_1_ClearInterrupt();
    sendchunk=1;
}

void timerhandler()
{
   // CyBle_ProcessEvents();
    Timer_1_ClearInterrupt(Timer_1_INTR_MASK_TC);
}

void printdata(CYBLE_GATTC_HANDLE_VALUE_NTF_PARAM_T * data)
{
    uint16 i=0;
    CYBLE_GATT_HANDLE_VALUE_PAIR_T		writeHandle;
    printf("The value belongs to the attribute is  %d\r\n", data->handleValPair.attrHandle);
    printf("The length of the characteristic notified to central is %d \r\n", data->handleValPair.value.len);
    printf("The data is ");
    for (i=0;i<data->handleValPair.value.len;i++)
    {
    printf("%02X ", data->handleValPair.value.val[i]);
    }
    printf("\r\n");
    printf("\r\n");
    printf("\r\n");    
}
    uint8 writedata[5]={0xAA, 0xAA, 0xAA, 0xAA, 0xAA};
    uint8 wwrdata[5]={0xBB, 0xBB, 0xBB, 0xBB, 0xBB};
    uint8 wlongdata[512];
    uint8 rlongdata[512];
    
 CYBLE_GATTC_READ_BLOB_REQ_T readBlobReqParam;   
    
    
    
    void batterycallback(uint32 event, void* eventParam)
{
    if(0u != eventParam)
    {
        /* This dummy operation is to avoid warning about unused eventParam */
    }

    switch(event)
    {
        CYBLE_BAS_CHAR_VALUE_T *batteryvalue;
        case CYBLE_EVT_BASC_NOTIFICATION:
        printf("CYBLE_EVT_BASC_NOTIFICATION\r\n");
        batteryvalue = (CYBLE_BAS_CHAR_VALUE_T *)eventParam;
        //printf("Battery level is %dX", batteryvalue->value->val);
        break;  
    }
}
    
    
    
    
int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    CyBle_BasRegisterAttrCallback(batterycallback);
    isr_1_StartEx(pinhandler);
    isr_2_StartEx(timerhandler);
    UART_Start();
    Timer_1_Start();
    printf("Hello world \r\n");
    CyBle_Start(&stack_event_handler);
    
        for(i=0;i<1000;i++)
    {
        sendbuffer[i]=i;
    }
    CyBle_BasInit();  
    for(i=0;i<sizeof(wlongdata);i++)
    wlongdata[i]=i+5;
    
    for(;;)
    {
        CyBle_ProcessEvents();
        switch(presentstate)
        {
            case pendingflashwrite:
            //    if((cyBle_pendingFlashWrite != 0u) &&((UART_SpiUartGetTxBufferSize() + UART_GET_TX_FIFO_SR_VALID) == 0u))
        {
        // STORING BONDED INFORMATION TO FLASH 
        apiresult = CyBle_StoreBondingData(0u);
        if ( apiresult == CYBLE_ERROR_OK)
        {
        printf("Bonding data stored\r\n");
        printf("\r\n");
        paststate = pendingflashwrite;
        presentstate = idle;
        }
        else
        {
        printf ("Bonding data storing pending\r\n");
        }        
        }
            break;
        
             //GETTING PASSKEY FROM USER FOR AUTHENTICATION 
     case getpasskey:
     UART_UartPutString("Enter the 6 digit passkey:\r\n");   
     passkey = 0u;
     pow1 = 100000ul;
     for(i = 0u; i < CYBLE_GAP_USER_PASSKEY_SIZE; i++)
     {
     while((command = UART_UartGetChar()) == 0)
     {
     }                  
     // accept the digits that are in between the range '0' and '9'  
     if((command >= '0') && (command <= '9'))  
     {
     passkey += (uint32)(command - '0') * pow1;
     pow1 /= 10u;
     UART_UartPutChar(command); 
     }
     /* If entered digit is not in between the rnage '0' and '9'*/              
     else  
     {
     printf(" Wrong digit \r\n");
     break;
     }
     }
     CyBle_GapAuthPassKeyReply(cyBle_connHandle.bdHandle,passkey,1);
     paststate=presentstate;
     presentstate = idle;
     break;
       
    //case to enter yes or no for numeric comparison request
    char ch3=0;        
    case numericcomp:
            ch3=0;
            printf("Enter '1' to accept and '2' to reject\r\n");
            while((0u == ch3) | (ch3!='1' && ch3!='2'))
            {
            ch3=UART_UartGetChar();
            if(ch3=='1')
            {
             CyBle_GapAuthPassKeyReply(cyBle_connHandle.bdHandle, numcompkey, CYBLE_GAP_ACCEPT_PASSKEY_REQ);      
             printf("You entered %c\r\n",ch3);
             presentstate=idle;
             paststate= numericcomp;
            ch3=0;
            break;
            }
            else if(ch3=='2')
            {
             CyBle_GapAuthPassKeyReply(cyBle_connHandle.bdHandle, numcompkey, CYBLE_GAP_REJECT_PASSKEY_REQ);   
            presentstate=idle;
            paststate= numericcomp;
            ch3=0;
            break;
            }
            else if ((ch3!='1' && ch3!='2' && ch3!=0u))
            {
            UART_UartPutString("Invalid selection. Please select your option again\r\n");
            }
            }
            break;
        
        case idle:
        break;
        }

        if(sendchunk==1)
        {
            sendchunk=0;
            //printf("sending data\r\n");
            isr_2_Disable();
             //apiresult = CyBle_L2capChannelDataWrite(cyBle_connHandle.bdHandle, l2capCid, sendbuffer, cbfcPeerParameters.mtu);
            isr_2_Enable();
        }
        /* Place your application code here. */
//        if(CyBle_GetState()==CYBLE_STATE_CONNECTED)
//        {
//        char ch2=0;
//        printf("\r\n");
//        printf("ENTER YOUR SELECTION \r\n");
//        printf("1. Write to S1_C1\r\n");
//        printf("2. Read from S1_C1\r\n");
//        printf("3. \r\n");
//        printf("4. \r\n"); 
//        printf("5. Send Authentication request\r\n");
//        printf("6. \r\n");
//        printf("7. Write to S1_C1 without response\r\n");
//        printf("8. Write long data to S2_C1\r\n");
//        printf("9. Read long data from S2_C1\r\n");
//        
//        
//        while((0u == ch2) | (ch2!='1' && ch2!='2' && ch2!='3' && ch2!='4' && ch2!='5' && ch2!='6' && ch2!='7' && ch2!='8' && ch2!='9' && ch2!='A'))
//        {
//        ch2=UART_UartGetChar();
//        CyBle_ProcessEvents();
//        if(ch2=='1')
//        {
//        printf("You entered option 1\r\n");
//        CYBLE_GATTC_WRITE_REQ_T  s1c1;
//        
//        s1c1.attrHandle=CYBLE_S1_S1_C1_CHAR_HANDLE;       
//        s1c1.value.val= writedata;
//        s1c1.value.len=sizeof(writedata);            
//        CyBle_GattcWriteCharacteristicValue(cyBle_connHandle, &s1c1);
//        ch2=0;
//        break;
//        }
//        else if( ch2=='2')
//        {
//        printf("You entered option 2\r\n");
//        CyBle_GattcReadCharacteristicValue(cyBle_connHandle,CYBLE_S1_S1_C1_CHAR_HANDLE);
//        ch2=0;
//        break;
//        }
//        else if( ch2=='3')
//        {
//        printf("You entered option 3\r\n");
//        ch2=0;
//        break;
//        }
//        else if( ch2=='4')
//        {
//        printf("You entered option 4\r\n");
//        ch2=0;
//        break;
//        }
//        else if( ch2=='7')
//        {
//        printf("You entered option 7\r\n");
//        CYBLE_GATTC_WRITE_REQ_T  writewithoutresp;
//        writewithoutresp.attrHandle=CYBLE_S1_S1_C1_CHAR_HANDLE;;
//        writewithoutresp.value.val=wwrdata;
//        writewithoutresp.value.len=sizeof(wwrdata);            
//        CyBle_GattcWriteWithoutResponse(cyBle_connHandle, &writewithoutresp);
//        ch2=0;
//        break;
//        }
//        else if( ch2=='6')
//        {
//        printf("You entered option 6\r\n");
//        ch2=0;
//        break;
//        }
//        else if(ch2=='5')
//        {
//        CyBle_GapAuthReq(cyBle_connHandle.bdHandle, &cyBle_authInfo);
//        printf("You entered option 5\r\n");
//        ch2=0;
//        break;
//        }
//        else if(ch2=='8')
//        {
//        CYBLE_GATTC_PREP_WRITE_REQ_T longwriteParam;
//        printf("You entered option 8\r\n");
//        longwriteParam.offset =0x00;
//        longwriteParam.handleValuePair.attrHandle = CYBLE_S2_S2_C1_CHAR_HANDLE;
//        longwriteParam.handleValuePair.value.val = (uint8 *)wlongdata;
//        longwriteParam.handleValuePair.value.len = sizeof(wlongdata);
//        CyBle_GattcWriteLongCharacteristicValues(cyBle_connHandle, &longwriteParam);
//        ch2=0;
//        break;
//        }
//        else if(ch2=='9')
//        {
//          printf("You entered option 9\r\n");
//        readBlobReqParam.offset=0x00;
//        readBlobReqParam.attrHandle = CYBLE_S2_S2_C1_CHAR_HANDLE;
//        CyBle_GattcReadLongCharacteristicValues (cyBle_connHandle, &readBlobReqParam);
//          ch2=0;
//          break;
//        }
//        else if(ch2=='A')
//        {
////          apiresult=CyBle_BascGetCharacteristicValue (cyBle_connHandle, 0x00,0x01);
////        printf("API result is %d\r\n",apiresult);  
//        ch2=0;
//          break;
//        }
//        else if ((ch2!='1' && ch2!='2' && ch2!='3' && ch2!='4' && ch2!='5' && ch2!='6' && ch2!='7' && ch2!='8' && ch2!='9' && ch2!='A' &&ch2!=0u))
//        {
//        UART_UartPutString("Invalid selection. Please select your option again\r\n");
//        }
//        } 
//        }
    }
}

/* [] END OF FILE */
